//Joris Lambrecht
//20131112
//Oculus Rift Demo
#include <acknex.h>
#include <windows.h>
#include <d3d9.h>
#include "Oculus.c"

var esd;
var scale;


PANEL* display_panel =
{ 		
  layer =1;
  digits = (200, 210, "left/right: adjust EyeToScreen Distance", "Arial#18b", 1, NULL);
  digits = (200, 230, "up/down   : adjust Distortion Scale", "Arial#18b", 1, NULL);
  digits = (200, 250, "F1 : show Oculus HW Params", "Arial#18b", 1, NULL);
  digits = (200, 270, "F2 : toggle this display", "Arial#18b", 1, NULL);
  digits = (200, 290, "F3 : toggle color correction", "Arial#18b", 1, NULL);
  digits = (200, 310, "F4 : toggle distortion correction", "Arial#18b", 1, NULL);
  digits = (200, 330, "F5 : toggle projection translation", "Arial#18b", 1, NULL);
  digits = (200, 400, "IPI = %5.3fquants", "Arial#24b", 1, ipi);
  digits = (400, 400, "hFOV = %3.1f", "Arial#24b", 1, camera_left.arc);
  digits = (200, 430, "ESD = %5.3fm", "Arial#24b", 1, esd);
  digits = (400, 430, "Scale = %5.3f", "Arial#24b", 1, scale);
  digits = (200, 460, "h = %3.3f", "Arial#24b", 1, h);
  digits = (240, 520, "pan  = %4.1f", "Arial#24b", 1, camera_left.pan);
  digits = (240, 550, "tilt = %4.1f", "Arial#24b", 1, camera_left.tilt);
  digits = (240, 580, "roll = %4.1f", "Arial#24b", 1, camera_left.roll);
  flags = SHOW;
}

function ToggleDisplay()
{
	//switches display: lefteye/righteye/off
	static var mode=0;
	mode=cycle(mode+1,0,3);
	switch(mode){
		case 0:
			display_panel.pos_x=0;
			set(display_panel, SHOW);
			break;
		case 1:
			display_panel.pos_x=screen_size.x/2;
			set(display_panel, SHOW);
			break;
		default: 
			reset(display_panel, SHOW);
			break;
	}
}
function Exit()
{
	sys_exit("goodbye");
}	
function main()
{

	wait(1);
	fps_max = 120;
	video_set(1280, 800,0,1);

	on_esc = Exit;
	on_f2 = ToggleDisplay;
	on_f3 = toggleChromaticAberrationOR;
	on_f4 = toggleDistortionOR;
	on_f5 = toggleProjectionTranslationOR;

	level_load("world.wmb");
	initOR();
	updateViewsOR(); //use this function whenever screen changes size
	
	esd = OculusProps.EyeToScreenDistance;
	scale = OculusProps.DistortionScale;
	
	while(1){
		updateCamerasOR(); //updates camera position/orientation based on Oculus Head Tracking
		
		if(key_cur){
			while(key_cur) wait(1);
			esd +=0.001;
			setEyeToScreenDistanceOR(esd);
		}
		if(key_cul){
			while(key_cul) wait(1);
			esd -=0.001;
			setEyeToScreenDistanceOR(esd);
		}
		if(key_cuu){
			scale +=0.01*time_step;
			setDistortionScaleOR(scale);
		}
		if(key_cud){ 
			scale -=0.01*time_step;
			setDistortionScaleOR(scale);
		}
		
		if(key_f1) showPropsOR();
		
		wait(1);
	}
	
}





