//Texture2D Texture : register(t0);
//SamplerState Linear : register(s0);
Texture TargetMap;
sampler2D g_samSrcColor = sampler_state { texture = <TargetMap>; MipFilter = Linear;	};

float4 vecSkill1;//DistortK
float4 vecSkill5;//x,y,xCenterOffset, DistortScale
float4 vecSkill9;//Chromatic Aberration correction

	
float4 postprocessing_undistort(float2 texCoordIn : TEXCOORD0) : COLOR0 				
{
	float2 texCoordOut;
	
	float2 LensCenter = {vecSkill5.x+(0.5+vecSkill5.z*0.5)*0.5, vecSkill5.y + 0.5};
	float2 ScreenCenter = {vecSkill5.x + 0.25, vecSkill5.y + 0.5};
	float2 ScaleOut = {0.25/vecSkill5.w,  0.4/vecSkill5.w};
	float2 ScaleIn = {4.0, 2.5};
	float4 K = vecSkill1;
	float4 ChromAbParam = vecSkill9;
	float4 Color;
	
	float2 theta = (texCoordIn - LensCenter) * ScaleIn; //
	float rSq = theta.x * theta.x + theta.y * theta.y;
	float2 theta1 = theta * (K.x + K.y*rSq + K.z*rSq*rSq + K.w*rSq*rSq*rSq);
	
	// Detect whether blue texture coordinates are out of range
	// since these will scaled out the furthest.
	float2 thetaBlue = theta1 * (ChromAbParam.z + ChromAbParam.w * rSq);
	float2 tcBlue = LensCenter + ScaleOut * thetaBlue;
	
	if (any(clamp(tcBlue, ScreenCenter-float2(0.25,0.5), ScreenCenter+float2(0.25, 0.5)) - tcBlue))
		return 0;
	
	// Now do blue texture lookup.
	Color = tex2D( g_samSrcColor, tcBlue.xy);
	float tblue = Color.b; 
	// Do green lookup (no scaling).
	float2 tcGreen = LensCenter + ScaleOut * theta1;
	Color = tex2D( g_samSrcColor, tcGreen.xy);
	float tgreen = Color.g;
	// Do red scale and lookup.
	float2 thetaRed = theta1 * (ChromAbParam.x + ChromAbParam.y * rSq);
	float2 tcRed = LensCenter + ScaleOut * thetaRed;
	Color = tex2D( g_samSrcColor, tcRed.xy);
	float tred = Color.r;
	
//	float tblue = tex2D(g_samSrcColor, tcBlue).b; //TargetMap.Sample(tcBlue).b;
//	// Do green lookup (no scaling).
//	float2 tcGreen = LensCenter + ScaleOut * theta1;
//	float tgreen = tex2D(g_samSrcColor, tcGreen).g;
//	// Do red scale and lookup.
//	float2 thetaRed = theta1 * (ChromAbParam.x + ChromAbParam.y * rSq);
//	float2 tcRed = LensCenter + ScaleOut * thetaRed;
//	float tred = tex2D(g_samSrcColor, tcRed).r;
	
	return float4(tred, tgreen, tblue, 1);

	
	//return tex2D(g_samSrcColor, texCoordOut);
	
	
	
}

technique PostProcess 
{

	pass p1 
	{
		AlphaBlendEnable = false;	
		VertexShader = null;
		PixelShader = compile ps_2_0 postprocessing_undistort();
	}
}