//Texture2D Texture : register(t0);
//SamplerState Linear : register(s0);
Texture TargetMap;
sampler2D g_samSrcColor = sampler_state { texture = <TargetMap>; MipFilter = Linear;	};

float4 vecSkill1;//DistortK
float4 vecSkill5;//x,y,xCenterOffset, DistortScale

	
float4 postprocessing_undistort(float2 texCoordIn : TEXCOORD0) : COLOR0 				
{
	float2 texCoordOut;
	
	float2 LensCenter = {vecSkill5.x+(0.5+vecSkill5.z*0.5)*0.5, vecSkill5.y + 0.5};
	float2 ScreenCenter = {vecSkill5.x + 0.25, vecSkill5.y + 0.5};
	float2 ScaleOut = {0.25/vecSkill5.w,  0.4/vecSkill5.w};
	float2 ScaleIn = {4.0, 2.5};
	float4 K = vecSkill1;
	
	float2 theta = (texCoordIn - LensCenter) * ScaleIn; //
	float rSq = theta.x * theta.x + theta.y * theta.y;
	float2 rvector = theta * (K.x + K.y*rSq + K.z*rSq*rSq +	K.w*rSq*rSq*rSq);
	
	texCoordOut = LensCenter + ScaleOut*rvector;
	
	if (any(clamp(texCoordOut, ScreenCenter-float2(0.25,0.5), ScreenCenter+float2(0.25, 0.5)) - texCoordOut))
		return 0;
	
	return tex2D(g_samSrcColor, texCoordOut);
	
}

technique PostProcess 
{

	pass p1 
	{
		AlphaBlendEnable = false;	
		VertexShader = null;
		PixelShader = compile ps_2_0 postprocessing_undistort();
	}
}